/******************************************************************
 * analog_synth.h
 *
 *  Created on: Aug 13, 2024
 *      Author: sei_s
 *****************************************************************/

#ifndef INC_ANALOG_SYNTH_H_
#define INC_ANALOG_SYNTH_H_

/*=================================================================
    definitions
=================================================================*/


/*=================================================================
    global variable
=================================================================*/

extern int        play_mode;

extern int8_t     play_ch[16];

extern int        recording_flg;   // 1=recording is run 0=stop recording
extern int        playing_flg;     // 1=playing is run   0=stop playing

extern int        dump_pot_flg;
extern int        dump_key_flg;

/*=================================================================
    function prototype
=================================================================*/

extern void     analog_synth(void);
extern void     analog_voice_play(void);  // callback from TIM3 interrupt

extern void     midi_voice_release(int note_numb);
extern void     midi_voice_all_release(void);

extern void     init_parameter_set(void);
extern void     save_parameter(int numb);
extern int      load_parameter(int numb);

extern void     start_recording(int numb);
extern void     recording_parameter(void);
extern void     recording_midi_note(char buf[]);
extern void     recording_pause_time(void);
extern void     stop_recording(void);

extern void     start_playing(int numb);
extern void     stop_playing(void);



#endif /* INC_ANALOG_SYNTH_H_ */
/*** end of file **************************************************/
