/****************************************************************
 * eg.h
 *
 *  Created on: Aug 22, 2024
 *      Author: sei_s
 ***************************************************************/

#ifndef INC_EG_H_
#define INC_EG_H_

#include "synth.h"

/*===============================================================
     definition
===============================================================*/

//
//  EG state macro
//
#define ST_ATACK          0
//#define ST_DECAY          1
#define ST_SUSTAIN        2
#define ST_RELEASE        3

//
// EG type
//
#define EG_AR             0
#define EG_KEYOFF         1
#define EG_ASR            2

//
// EG number
//
#define EG1               0
#define EG2               1

//
// EG time ratio
//
#define EG_MIN_RATIO      (0.99F)     // about   12 ms
#define EG_MAX_RATIO      (0.999F)    // about 1150 ms
#define EG_RATIO_STEP     (0.0001F)


/*===============================================================
     global variable
===============================================================*/

extern volatile float     eg_atack_ratio[2];     // 0.99 - 0.9999 init 0.99(aboud 10msec)
//extern volatile float     eg_decay_ratio;        // 0.99 - 0.9999 init 0.999(about 100msec)
//extern volatile float     eg_sustain_level;      // 0.0 -  0.99999 init 0.8  80%
extern volatile float     eg_release_ratio[2];   // 0.99 - 0.9999 init 0.9999 (about 1000msec)

extern volatile int       eg_ptrn[2];            // EG_AR, EG_KEYOFF, EG_ASR
extern volatile float     eg_vco_mod_depth;      // MOD_MIN_DEPTH - MOD_MAX_DEPTH
extern volatile float     eg_vcf_mod_depth;      // 0.0 < 1.0


/*===============================================================
    function prototype
===============================================================*/

extern void   eg_init(void);
extern void   eg_process(MIDI_NOTE *note);


#endif /* INC_EG_H_ */
/*** end of file ***********************************************/
