/****************************************************************
 * filter.h
 *
 *  Created on: Aug 22, 2024
 *      Author: sei_s
 ***************************************************************/

#ifndef INC_FILTER_H_
#define INC_FILTER_H_

#include "synth.h"

/*===============================================================
     definition
===============================================================*/

// typedefine
//
// filter parameter
//
typedef struct {
	float b0_a0;
	float b1_a0;
	float b2_a0;
    float a1_a0;
    float a2_a0;
} F_COEFS;

#define   MAX_CUT_OFF       127
#define   MIN_CUT_OFF       0

#define   MAX_RES           7
#define   MIN_RES           0


/*===============================================================
     global variable
===============================================================*/

extern volatile int     lpf_cut;           // lpf cut off freq.
extern volatile int     lpf_res;           // lpf resonance
extern volatile int     hpf_cut;           // hpf cut off freq
extern volatile int     hpf_res;           // lpf resonance

extern volatile float   vcf_kbd_mod_depth; // keyborad modulation depth
extern volatile float   vcf_lfo1_mod_depth;
extern volatile float   vcf_lfo2_mod_depth;
extern volatile float   vcf_eg1_mod_depth;  // eg modulation depth
extern volatile float   vcf_eg2_mod_depth;  // eg modulation depth


/*===============================================================
    function prototype
===============================================================*/

extern void      filter_init(void);
extern float     lpf_process(MIDI_NOTE *note);
extern float     hpf_process(MIDI_NOTE *note);


#endif /* INC_FILTER_H_ */
/*** end of file ***********************************************/


