/*
 * key.h
 *
 *  Created on: Oct 29, 2024
 *      Author: sei_s
 */

#ifndef INC_KEY_H_
#define INC_KEY_H_


/*===============================================================
     definition
===============================================================*/

// key switch id
#define   ID_EG_TRIG_LFO1    0
#define   ID_EG_TRIG_LFO2    1
#define   ID_EG1_AR          2
#define   ID_EG1_ASR         3
#define   ID_EG2_AR          4
#define   ID_EG2_ASR         5
#define   ID_VCO_WAVE        6

#define   ID_AMP_CTL_EG1     7
#define   ID_AMP_CTL_EG2     8
#define   ID_LFO_WAVE        9
#define   ID_VCO_ECHO        10
#define   ID_MENU_SET        11
#define   ID_MENU_UP         12
#define   ID_MENU_DOWN       13


#define   KEY_ON             0
#define   KEY_OFF            1


/*===============================================================
     global variable
===============================================================*/

extern int      key_switch[14];


/*===============================================================
    function prototype
===============================================================*/

extern void keyboard_control(void);
extern void read_key_switch(void);
extern void read_menu_key(void);
extern void dump_key(void);


#endif /* INC_KEY_H_ */
/*** end of file ***********************************************/
