/****************************************************************
     notefreq.h
     midi note frequency value
     2021.12 (C) suwa-koubou
*****************************************************************/

#ifndef INC_NOTEFREQ_H_
#define INC_NOTEFREQ_H_

const float note_freq[136] = { // note_freq(Hz)
// note_number  key_name  note_freq
    /*   0  C -2   */  8.18,
    /*   1  C#-2   */  8.66,
    /*   2  D -2   */  9.18,
    /*   3  D#-2   */  9.72,
    /*   4  E -2   */ 10.30,
    /*   5  F -2   */ 10.91,
    /*   6  F#-2   */ 11.56,
    /*   7  G -2   */ 12.25,
    /*   8  G#-2   */ 12.98,
    /*   9  A -2   */ 13.75,
    /*  10  A#-2   */ 14.57,
    /*  11  B -2   */ 15.43,
    /*  12  C -1   */ 16.35,
    /*  13  C#-1   */ 17.32,
    /*  14  D -1   */ 18.35,
    /*  15  D#-1   */ 19.45,
    /*  16  E -1   */ 20.60,
    /*  17  F -1   */ 21.83,
    /*  18  F#-1   */ 23.12,
    /*  19  G -1   */ 24.50,
    /*  20  G#-1   */ 25.96,
    /*  21  A -1   */ 27.50,
    /*  22  A#-1   */ 29.14,
    /*  23  B -1   */ 30.87,
    /*  24  C  0   */ 32.70,
    /*  25  C# 0   */ 34.65,
    /*  26  D  0   */ 36.71,
    /*  27  D# 0   */ 38.89,
    /*  28  E  0   */ 41.20,
    /*  29  F  0   */ 43.65,
    /*  30  F# 0   */ 46.25,
    /*  31  G  0   */ 49.00,
    /*  32  G# 0   */ 51.91,
    /*  33  A  0   */ 55.00,
    /*  34  A# 0   */ 58.27,
    /*  35  B  0   */ 61.74,
    /*  36  C  1   */ 65.41,
    /*  37  C# 1   */ 69.30,
    /*  38  D  1   */ 73.42,
    /*  39  D# 1   */ 77.78,
    /*  40  E  1   */ 82.41,
    /*  41  F  1   */ 87.31,
    /*  42  F# 1   */ 92.50,
    /*  43  G  1   */ 98.00,
    /*  44  G# 1   */ 103.83,
    /*  45  A  1   */ 110.00,
    /*  46  A# 1   */ 116.54,
    /*  47  B  1   */ 123.47,
    /*  48  C  2   */ 130.81,
    /*  49  C# 2   */ 138.59,
    /*  50  D  2   */ 146.83,
    /*  51  D# 2   */ 155.56,
    /*  52  E  2   */ 164.81,
    /*  53  F  2   */ 174.61,
    /*  54  F# 2   */ 185.00,
    /*  55  G  2   */ 196.00,
    /*  56  G# 2   */ 207.65,
    /*  57  A  2   */ 220.00,
    /*  58  A# 2   */ 233.08,
    /*  59  B  2   */ 246.94,
    /*  60  C  3   */ 261.63,
    /*  61  C# 3   */ 277.18,
    /*  62  D  3   */ 293.66,
    /*  63  D# 3   */ 311.13,
    /*  64  E  3   */ 329.63,
    /*  65  F  3   */ 349.23,
    /*  66  F# 3   */ 369.99,
    /*  67  G  3   */ 392.00,
    /*  68  G# 3   */ 415.30,
    /*  69  A  3   */ 440.00,
    /*  70  A# 3   */ 466.16,
    /*  71  B  3   */ 493.88,
    /*  72  C  4   */ 523.25,
    /*  73  C# 4   */ 554.37,
    /*  74  D  4   */ 587.33,
    /*  75  D# 4   */ 622.25,
    /*  76  E  4   */ 659.26,
    /*  77  F  4   */ 698.46,
    /*  78  F# 4   */ 739.99,
    /*  79  G  4   */ 783.99,
    /*  80  G# 4   */ 830.61,
    /*  81  A  4   */ 880.00,
    /*  82  A# 4   */ 932.33,
    /*  83  B  4   */ 987.77,
    /*  84  C  5   */ 1046.50,
    /*  85  C# 5   */ 1108.73,
    /*  86  D  5   */ 1174.66,
    /*  87  D# 5   */ 1244.51,
    /*  88  E  5   */ 1318.51,
    /*  89  F  5   */ 1396.91,
    /*  90  F# 5   */ 1479.98,
    /*  91  G  5   */ 1567.98,
    /*  92  G# 5   */ 1661.22,
    /*  93  A  5   */ 1760.00,
    /*  94  A# 5   */ 1864.66,
    /*  95  B  5   */ 1975.53,
    /*  96  C  6   */ 2093.00,
    /*  97  C# 6   */ 2217.46,
    /*  98  D  6   */ 2349.32,
    /*  99  D# 6   */ 2489.02,
    /* 100  E  6   */ 2637.02,
    /* 101  F  6   */ 2793.83,
    /* 102  F# 6   */ 2959.96,
    /* 103  G  6   */ 3135.96,
    /* 104  G# 6   */ 3322.44,
    /* 105  A  6   */ 3520.00,
    /* 106  A# 6   */ 3729.31,
    /* 107  B  6   */ 3951.07,
    /* 108  C  7   */ 4186.01,
    /* 109  C# 7   */ 4434.92,
    /* 110  D  7   */ 4698.64,
    /* 111  D# 7   */ 4978.03,
    /* 112  E  7   */ 5274.04,
    /* 113  F  7   */ 5587.65,
    /* 114  F# 7   */ 5919.91,
    /* 115  G  7   */ 6271.93,
    /* 116  G# 7   */ 6644.88,
    /* 117  A  7   */ 7040.00,
    /* 118  A# 7   */ 7458.62,
    /* 119  B  7   */ 7902.13,
    /* 120  C  8   */ 8372.02,
    /* 121  C# 8   */ 8869.84,
    /* 122  D  8   */ 9397.27,
    /* 123  D# 8   */ 9956.06,
    /* 124  E  8   */ 10548.08,
    /* 125  F  8   */ 11175.30,
    /* 126  F# 8   */ 11839.82,
    /* 127  G  8   */ 12543.85,
	/* 128  G# 8   */ 13289.75,
	/* 129  A  8   */ 14080.00,
	/* 130  A# 8   */ 14917.24,
	/* 131  B  8   */ 15804.27,
	/* 132  C  9   */ 16744.04,
	/* 133  C# 9   */ 17739.69,
	/* 134  D  9   */ 18794.55,
	/* 135  D# 9   */ 19912.13,
  };

#endif /* INC_NOTEFREQ_H_ */

/*** end of notefreq.h *****************************************/
