/*
 * potentio.h
 *
 *  Created on: Aug 28, 2024
 *      Author: sei_s
 */

#ifndef INC_POTENTIO_H_
#define INC_POTENTIO_H_


/*===============================================================
     definition
===============================================================*/

// potnetio id

#define   ID_VCO_TUNE        0
#define   ID_VCO_PORTAMENT   1
#define   ID_FM_DEPTH        2
#define   ID_VCO_EG_MOD      3
#define   ID_VCO_LFO_MOD     4
#define   ID_LPF_FREQ        5
#define   ID_LPF_RES         6
#define   ID_LPF_KBD_MOD     7
#define   ID_LPF_EG_MOD      8
#define   ID_LPF_LFO_MOD     9
#define   ID_HPF_FREQ       10
#define   ID_HPF_RES        11
#define   ID_EG1_ATACK      12
#define   ID_EG1_RELEASE    13
#define   ID_EG2_ATACK      14
#define   ID_EG2_RELEASE    15
#define   ID_LFO1_FREQ      16
#define   ID_LFO2_FREQ      17
#define   ID_VCO_TREMORO    18
#define   ID_VCO_CHORUS     19


typedef struct {
	int  prev[16];
	int  idx;
	int  sum;
	int  val;
	int  chg_flg;
} POTENTIO;


/*===============================================================
     global variable
===============================================================*/

extern POTENTIO pot[20];
extern int      pot_read_flg;

/*===============================================================
    function prototype
===============================================================*/

extern void potentio_control(void);
extern void read_potentio(void);
extern void dump_potentio(void);

#endif /* INC_POTENTIO_H_ */
/*** end of file ***********************************************/
