/****************************************************************
 * amp.c
 *
 *  Created on: Aug 22, 2024
 *      Author: sei_s
 ***************************************************************/

#include "synth.h"
#include "eg.h"
#include "osc.h"
#include "lfo.h"
#include "filter.h"
#include "amp.h"


/*===============================================================
     global variable
===============================================================*/

volatile int       amp_ctl;            // CTL_KEYBRD/CTL_EG


/*===============================================================
    function prototype
===============================================================*/

void     amp_init(void);
float    amp_process(MIDI_NOTE *note, float in);


/*===============================================================
    VCA initialize
===============================================================*/

void amp_init(void)
{
	amp_ctl = AMP_CTL_KBD;
}


/*===============================================================
    amp process
===============================================================*/

inline float amp_process(MIDI_NOTE *note, float in)
{
	if(amp_ctl == AMP_CTL_KBD){
        if(note->state == ST_ATACK){
		    return note->velocity *in;
		}else if(note->state == ST_RELEASE){
			note->use = 0;
			return 0;
		}
	}

	// cotrolle by EG
	if(amp_ctl == AMP_CTL_EG1){
	    return note->velocity * note->eg[EG1].level * in;
	}else{
	    return note->velocity * note->eg[EG2].level * in;
	}

}


/*** end of file ***********************************************/

